--- old/usr/src/uts/common/io/lofi.c	Thu Oct 31 17:56:14 2013
+++ new/usr/src/uts/common/io/lofi.c	Thu Oct 31 17:56:14 2013
@@ -475,14 +475,14 @@
 		return (ENXIO);
 	}
 
-	if (mark_opened(lsp, otyp) == -1) {
+	if (lsp->ls_readonly && (flag & FWRITE)) {
 		mutex_exit(&lofi_lock);
-		return (EINVAL);
+		return (EROFS);
 	}
 
-	if (lsp->ls_readonly && (flag & FWRITE)) {
+	if (mark_opened(lsp, otyp) == -1) {
 		mutex_exit(&lofi_lock);
-		return (EROFS);
+		return (EINVAL);
 	}
 
 	mutex_exit(&lofi_lock);
